<template>
  <div class="container player-list">
    <div class="box">
      <h1 class="title">Player list</h1>
      <Table v-if="!error" :config="config" :items="players" :loading="loading" @rowClick="rowClick" />
      <Pagination v-if="success" :page="page" :size="size" :total="total" @setPage="setPage" />
      <Message v-if="error" header="Error" type="danger">Failed to load data</Message>
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, reactive, watchEffect, toRefs, watch } from 'vue'
import { useRoute, useRouter } from 'vue-router'
import { useStore, ActionTypes, LoadingState } from '@/store/index'
import { footInches, convertLocationQueryValue } from '@/utils'
import Table from '@/components/Table.vue'
import Pagination from '@/components/Pagination.vue'
import Message from '@/components/Message.vue'

export default defineComponent({
  name: 'PlayerList',
  components: { Table, Pagination, Message },
  setup() {
    const route = useRoute()
    const router = useRouter()

    const config = {
      columns: {
        first_name: {
          title: 'First name',
        },
        last_name: {
          title: 'Last name',
        },
        position: {
          title: 'Position',
        },
        height: {
          title: 'Height',
        },
        weight_pounds: {
          title: 'Weight',
        },
      },
      rows: {
        clickEnabled: true,
      },
    }

    const store = useStore()
    const loading = computed(() => store.state.playersLoading === LoadingState.LOADING)
    const success = computed(() => store.state.playersLoading === LoadingState.SUCCESS)
    const error = computed(() => store.state.playersLoading === LoadingState.ERROR)
    const pagination = reactive({ page: 0, size: 0, total: 0 })

    watchEffect(() => {
      const { current_page, per_page, total_pages } = store.state.playersPagination

      pagination.page = current_page
      pagination.size = per_page
      pagination.total = total_pages
    })

    const players = computed(() =>
      store.getters.playerListWithoutTeamName.map(({ height_feet, height_inches, ...player }) => ({
        ...player,
        height: footInches(height_feet, height_inches),
      }))
    )

    watch(
      () => route.query,
      (query) => {
        const { page, per_page } = query
        store.dispatch(ActionTypes.GetPlayerList, { page: convertLocationQueryValue(page), per_page: convertLocationQueryValue(per_page) })
      },
      { immediate: true }
    )

    const setPage = (value: number) => router.push({ name: 'PlayerList', query: { ...route.query, page: value.toString() } })
    const rowClick = (id: number) => router.push({ name: 'PlayerView', params: { id } })

    return { loading, success, error, players, config, setPage, rowClick, ...toRefs(pagination) }
  },
})
</script>
